/*
 *  My Certificate Wizard
 *
 *  Copyright (C) 2004 Vlada Macek <mycert@seznam.cz>
 *
 ** $Id: mycert.h,v 1.5 2004/10/19 12:57:54 tuttle Exp $ **
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program (see the file COPYING included with this
 *  distribution); if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#define VERSION "Version 0.2beta"

/* The text displayed by the About dialog (icon button) */

#define ABOUTTEXT "My Certificate Wizard\n" VERSION "\n\nhttp://www.sweb.cz/mycert\n\n(c) 2004 Vlada Macek\nReleased under the terms of GNU General Public License.\n\nThe development was funded by Hieronymus,\ntranslation and software localization company.\nhttp://www.hiero.cz/us"

#define MAXLINELEN 128
#define MINPASSLEN 4

/* Filename extensions. */

#define KEY_EXT "key"
#define REQ_EXT "req"
#define CERT_EXT "cert"
#define OVPN_EXT "ovpn"

typedef struct {
	char MyConfig[MAX_PATH+1];
	char KeyFilePath[MAX_PATH+1];
	char OutFilePath[MAX_PATH+1];
	char CertFilePath[MAX_PATH+1];
	char OVPNTemplate[MAX_PATH+1];
	char OVPNFilePath[MAX_PATH+1];
	char OutFolder[MAX_PATH+1];
	char KeyExt[16], CertExt[16], ReqExt[16], OvpnExt[16];
	BOOL cfg_nodes;
	char *opensslerr;
	char msgbuf[50*1024];
	HWND myH;
	HINSTANCE myI;
} GLOBALS;

/* request.c */
int Atoi(const char *str);
char *CreateRequest(char *keyout, char *outfile, int nodes, char *passout);

/* misc.c */
char *CfgGetValue(char *key);
char *DlgGetValue(int key);
void safe_string(char *cp);
void ErrorExit(LPTSTR lpszFunction);
BOOL CopyExtraFiles();
void DestroyBillGatesEmpire();
BOOL ChooseFolder(HWND owner, char *pszDir);
BOOL CALLBACK DONEDialogFunc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL ProcessOVPNTemplate();
void ResolveConfigFilename(char *forcepath);

/* *** */

/* snprintf with guaranteed null termination */
#define mysnprintf(out, args...) (snprintf(out, sizeof(out), args), out[sizeof(out)-1] = '\0', out)

/* universal message box */
#define MsgBox(caption, options, args...) MessageBox(globals.myH, mysnprintf(globals.msgbuf, args), caption, options)

/*
#define mysnprintf(out, args...) \
	{ \
		snprintf(out, sizeof(out), args); \
		out[sizeof(out) - 1] = '\0'; \
	}


#define ShowMsg(caption, args...) \
	{ \
		mysnprintf(msgbuf, args); \
		MessageBox(NULL, x_msg, caption, MB_OK | MB_SETFOREGROUND); \
	}
*/

/* These were ripped from the mycert.rc

    PUSHBUTTON      "Create &Request", IDOK, 74, 245, 68, 14
    PUSHBUTTON      "&Help", IDHELPBUT, 158, 245, 40, 14
    PUSHBUTTON      "Cancel", IDCANCEL, 214, 245, 40, 14

    EDITTEXT        TEXT_DONEMSG, 15, 95, 295, 163, ES_MULTILINE | ES_AUTOVSCROLL | ES_AUTOHSCROLL | ES_READONLY | ES_WANTRETURN

*/

/*
	MessageBox() overview:
	http://www.functionx.com/win32/Lesson04.htm
*/
